<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="52px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="content" label="内容">
                <el-input v-model="formData.content"></el-input>
            </el-form-item>
            <el-form-item prop="url" label="中文文件">
                <el-upload
                        class="avatar-uploader"
                        :action="uploadUrl"
                        :limit="1"
                        :show-file-list="true"
                        :on-success="onSuccess"
                        v-model="formData.url"
                        :beforeUpload="beforeAvatarUpload">
                    <el-button size="small" type="primary">点击上传</el-button>
                </el-upload>
                <!--<file-upload v-model="formData.url">
                </file-upload>-->
            </el-form-item>
            <el-form-item prop="enUrl" label="英文文件">
                <el-upload
                        class="avatar-uploader"
                        :action="uploadUrl"
                        :limit="1"
                        :show-file-list="true"
                        :on-success="onSuccess2"
                        v-model="formData.enUrl"
                        :beforeUpload="beforeAvatarUpload">
                    <el-button size="small" type="primary">点击上传</el-button>
                </el-upload>
                <!--<file-upload v-model="formData.url">
                </file-upload>-->
            </el-form-item>
            <el-form-item prop="thUrl" label="泰文文件">
                <el-upload
                        class="avatar-uploader"
                        :action="uploadUrl"
                        :limit="1"
                        :show-file-list="true"
                        :on-success="onSuccess3"
                        v-model="formData.thUrl"
                        :beforeUpload="beforeAvatarUpload">
                    <el-button size="small" type="primary">点击上传</el-button>
                </el-upload>
                <!--<file-upload v-model="formData.url">
                </file-upload>-->
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    import resolveUrl from 'resolve-url';

    export default {
        name: 'VoiceEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('voice/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
            this.uploadUrl = resolveUrl(this.$baseUrl, 'upload/file');
        },
        data() {
            return {
                saving: false,
                formData: {},
                rules: {},
                uploadLoading: false,
                uploadUrl: '',
            }
        },

        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/voice/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/voice/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
            onSuccess(res, file) {
                this.uploadLoading = false;
                this.formData.url = res;

                this.$message.success('上传成功');
            },
            onSuccess2(res, file) {
                this.uploadLoading = false;
                this.formData.enUrl = res;

                this.$message.success('上传成功');
            },
            onSuccess3(res, file) {
                this.uploadLoading = false;
                this.formData.thUrl = res

                this.$message.success('上传成功');
            },

            beforeAvatarUpload(file) {
                this.uploadLoading = true;
                var testmsg = file.name.substring(file.name.lastIndexOf('.') + 1)
                const extension = testmsg === 'mp3'
                if (!extension) {
                    this.$message({
                        message: "上传文件只能是mp3格式！",
                        type: 'error'
                    })
                }
                return extension;
            }
        }
    }
</script>
<style lang="less" scoped>
</style>
